association/urls.py
from django.contrib import admin
from django.urls import path, include
from . import views

urlpatterns = [
    path('', views.index, name='page_accueil'),
    path('contact', views.contact, name='page_contact'),

    path('pdg/', include('authentification.urls')),
    path('core/', include('core.urls')),

    path('admin/', admin.site.urls),
]

core/urls.py
from django.urls import path
from . import views

app_name = 'core'
urlpatterns = [

     # Route des pages autorisées aux utilisateurs connectés
     path('tableau-de-bord/', views.dashbord_pdg, name='page_dashbord'),
     path('mon-profil/', views.profile_pdg, name='page_profile'),
     path('creation-de-groupe/', views.create_group_pdg, name='page_new_group'),
     path('rejoindre-un-groupe/', views.join_group_pdg, name='page_join_group'),
     path('mes-groupes/', views.groups_pdg, name='page_groups'),
     path('mon-groupe/<str:code>/detail/',
          views.group_detail_pdg, name='page_detail_group'),
     path('mes-messages/', views.messages_pdg, name='page_messages'),
     path('validation-en-attente/',
          views.atendance_validation_pdg, name='page_validation'),
     path('validation-en-attente/<str:id>/validate/', views.groupe_validation, name='page_validate'),
     path('configuration/', views.settings_pdg, name='page_settings'),
]

core/models.py
from django.db import models
from django.contrib.auth.models import User
import uuid

# Create your models here.


def get_auto_code():
    return uuid.uuid1().hex[:8].upper()


class Groupe(models.Model):
    name = models.CharField(max_length=128)
    description = models.TextField(null=True)
    #code = models.CharField(max_length=8, unique=True, default=get_auto_code())
    code = models.CharField(max_length=8, unique=True)
    adhesion_price = models.IntegerField(null=True, blank=True)
    cotisation_price = models.IntegerField(null=True, blank=True)
    add = models.DateTimeField(auto_now_add=True, verbose_name='Créer le')

    def __str__(self):
        return "%s" % self.name

    def member_count(self):
        return self.group_members.all().count()


# Adherent du groupe
class Member(models.Model):
    groupe = models.ForeignKey(
        Groupe, on_delete=models.CASCADE, related_name="group_members")
    user = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name="user_members")
    statut = models.BooleanField(default=False)
    is_admin = models.BooleanField(default=False)
    add = models.DateTimeField(auto_now_add=True, verbose_name='Ajouté le')
    adhesion_price = models.IntegerField(null=True, blank=True)

    class Meta:
        constraints = [models.UniqueConstraint(
            fields=['groupe', 'user'], name='existante au groupe')]


class Event(models.Model):
    name = models.CharField(max_length=200)
    amount = models.PositiveIntegerField(default=0)
    start_date = models.DateField()
    end_date = models.DateField()
    received_amount = models.PositiveIntegerField(default=0)
    paid_amount = models.PositiveIntegerField(default=0)
    group_code = models.CharField(max_length=8, db_index=True)
    created_date = models.DateField(auto_now_add=True)

    def __str__(self):
        return "%s" % self.name


class Meet(models.Model):
    date = models.DateField()
    amount = models.PositiveIntegerField(default=0)
    group_code = models.CharField(max_length=8, db_index=True)
    file = models.FileField(null=True)
    created_date = models.DateField(auto_now_add=True)


class Photo(models.Model):
    created_date = models.DateField(auto_now_add=True)
    meet = models.ForeignKey(Meet, on_delete=models.CASCADE)
    link = models.CharField(max_length=200)


class Contribution(models.Model):
    state = models.BooleanField(default=False)
    paiement_mode = models.CharField(max_length=100)
    reference = models.CharField(max_length=100)
    amount = models.IntegerField()
    presence = models.BooleanField(default=False)
    meet = models.ForeignKey(Meet, on_delete=models.CASCADE)
    member = models.ForeignKey(Member, on_delete=models.CASCADE)
    created_date = models.DateField(auto_now_add=True)


class CashType(models.Model):
    state = models.BooleanField(default=False)
    name = models.CharField(max_length=100)

    def __str__(self):
        return "%s" % self.name


class Cash(models.Model):
    amount = models.IntegerField(default=0)
    member = models.ForeignKey(Member, on_delete=models.CASCADE, db_index=True)
    type_cash = models.ForeignKey(CashType, on_delete=models.CASCADE)


class Operation(models.Model):
    operation_tag = {
        ("entrance", "Entrée"),
        ("out", "Sortie"),
    }
    name = models.CharField(max_length=200)
    description = models.TextField()
    type = models.CharField(max_length=8, choices=operation_tag)
    date = models.DateField()
    created_date = models.DateField(auto_now_add=True)

    def __str__(self):
        return "%s" % self.name

# Adhesion


class MemberShip(models.Model):
    date = models.DateField()
    amount = models.IntegerField(default=0)
    group_code = models.CharField(max_length=8, db_index=True)
    member = models.ForeignKey(Member, on_delete=models.CASCADE)


class EventMember(models.Model):
    member = models.ForeignKey(Member, on_delete=models.CASCADE)
    event = models.ForeignKey(Event, on_delete=models.CASCADE)
    created_date = models.DateField(auto_now_add=True)

core/views.py
#!/usr/bin/env python
# -*- coding: utf-8 -*-*
from django.shortcuts import render, redirect
from django.http import HttpResponse, HttpResponseRedirect

from django.contrib import messages
from django.utils.safestring import mark_safe

# requis pour la connexion
# Decorateurs
from django.contrib.auth.decorators import login_required
from django.urls import reverse
from .models import Groupe, Member
from django.db.models import Q

import uuid
import random

def shuffle_characters(srt):
    charlst = list(srt)        # convert the string into a list of characters
    random.shuffle(charlst)     # shuffle the list of characters randomly
    new_word = ''.join(charlst)
    return new_word

def get_auto_code():
    return uuid.uuid1().hex[:8].upper()


@login_required(login_url="pdg:page_inscription")
def dashbord_pdg(request):
    data = {
        'page': {
            'title': 'Tableau de bord',
            'dashbord_active': True,
        },
    }
    return render(request, 'core/dashbord.html', data)


@login_required(login_url="pdg:page_inscription")
def profile_pdg(request):
    data = {
        'page': {
            'title': 'Mon profil',
            'profile_active': True,
        },
    }
    return render(request, 'core/profile.html', data)


@login_required(login_url="pdg:page_inscription")
def create_group_pdg(request):

    if request.method == 'POST':
        # Recuperation des donnees postées
        nom = request.POST.get('name')
        code = get_auto_code()
        description = request.POST.get('description')
        montant_adhesion = request.POST.get('adhesion_price')
        montant_cotisation = request.POST.get('cotisation_price')

        # Controle de la validité des données
        if nom:
            # Sauvegarde de groupe dans la base de données
            
            while Groupe.objects.filter(code=code).exists():
                code = shuffle_characters(code)                
            
            groupePdg = Groupe.objects.create(
                name=nom, code=code, description=description, adhesion_price=montant_adhesion, cotisation_price=montant_cotisation)
            # Creation de adherent et inscrit le createur du groupe comme admin
            Member.objects.create(
                groupe=groupePdg, user=request.user, statut=True, is_admin=True, adhesion_price=groupePdg.adhesion_price)
            # Message de succes quand c'est enregistré
            messages.success(
                request, mark_safe(f"Votre groupe &laquo;<b> {nom} </b>  &raquo; a été créé !"))
            # Redirection sur la page contact
            return redirect('core:page_groups')

    data = {
        'page': {
            'title': 'Créer un groupe',
            'new_group_active': True,
        },
    }
    return render(request, 'core/new_group.html', data)


@login_required(login_url="pdg:page_inscription")
def join_group_pdg(request):
    # recuperer le code saisi
    codeSaisi = request.POST.get('code')
    # Controle de la validité des données
    if codeSaisi and len(codeSaisi) == 8:
        try:
            groupePdg = Groupe.objects.get(code=codeSaisi)
            if groupePdg:
                Member.objects.create(
                    groupe=groupePdg, user=request.user, adhesion_price=groupePdg.adhesion_price)
                messages.success(request, mark_safe(
                    f"Vous etes en attente de validation par l'admin du groupe &laquo;<b> {groupePdg} </b>  &raquo;!"))
            return redirect('core:page_join_group')

        except Groupe.DoesNotExist as notFound:
            messages.warning(request, mark_safe(f"Groupe introuvable!"))

            return redirect('core:page_join_group')
    elif codeSaisi:
        messages.warning(
            request, mark_safe(f"Code &laquo;<b> {codeSaisi} </b>  &raquo; invalide"))
    data = {
        'page': {
            'title': 'Rejoindre un groupe',
            'join_group_active': True,
        },
    }
    return render(request, 'core/join_group.html', data)


@login_required(login_url="pdg:page_inscription")
def groups_pdg(request):
    userGroups = Member.objects.filter(user=request.user.id, statut=True)
    data = {
        'page': {
            'title': 'Mes groupes',
            'groups_active': True,
        },
        'members': userGroups,
    }
    return render(request, 'core/groups.html', data)


@login_required(login_url="pdg:page_inscription")
def group_detail_pdg(request, code):          
    try:
        #groupePdg = Groupe.objects.get(code=code)
        groupePdg = Groupe.objects.get(code=code)
        liste_membres_groupe = Member.objects.filter(Q(groupe=groupePdg.id), Q(statut=True))
                
    except(KeyError, Groupe.DoesNotExist, NameError):
        #Reafficher le formulaire de vote
        messages.warning(request, mark_safe(f"Groupe introuvable!"))   
        return redirect('core:page_groups') 

    data = {
        'page': {
            'title': 'Detail du groupe',
            'groups_active': True,
        },
        'groupe': groupePdg,
        'members': liste_membres_groupe,
    }
    return render(request, 'core/detail_group.html', data)


@login_required(login_url="pdg:page_inscription")
def atendance_validation_pdg(request):
    #userGroups = Member.objects.filter(user=request.user.id, statut=False)
    #userGroups = Member.objects.filter(~Q(user_id=request.user.id) , Q(statut=False))
    #member = Member.objects.filter(user=request.user).filter(is_admin=True).filter(status=False)
    #groupsID = [_.groupe.id  for _ in member ]
    #userGroups = Member.objects.filter(**{'user': request.user, 'is_admin':True, 'statut': False})
    #userGroups = Member.objects.exclude(user_id=request.user.id).filter(status=False)
    #userGroups = Member.objects.filter(~Q(user_id=request.user.id) & Q(statut=False) & Q(is_admin=False))
    
    member = Member.objects.filter(user=request.user).filter(is_admin=True)
    groupsID = [_.groupe.id  for _ in  member ]
    userGroups = Member.objects.filter(groupe__in=groupsID).filter(statut=False).exclude(user=request.user)
    #userGroups = Member.objects.filter(groupe__in=groupsID)
    
    print(userGroups)
    
    
    data = {
        'page': {
            'title': 'Validations en attente',
            'validation_active': True,
        },
        'members': userGroups,
    }
    return render(request, 'core/validation.html', data)


@login_required(login_url="pdg:page_inscription")
def messages_pdg(request):
    data = {
        'page': {
            'title': 'Mes messages',
            'messages_active': True,
        },
    }
    return render(request, 'core/messages.html', data)


@login_required(login_url="pdg:page_inscription")
def settings_pdg(request):
    data = {
        'page': {
            'title': 'Configuration',
            'settings_active': True,
        },
    }
    return render(request, 'core/settings.html', data)

def groupe_validation(request, id):
    """ ToDo: notifier aux demandeurs (email, SMS) """
    #Member.objects.filter(pk=survey.pk).update(active=True)
    membre = Member.objects.get(pk=id)
    membre.statut = True
    membre.save()
    messages.success(request, mark_safe(
                f"La demande d'adhesion a été validée avec succès !"))
    return redirect('core:page_validation')

core/templates/core/dashbord.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-dashboard"></i> {{ page.title }}</span></h2>

                        <div class="row">
                            {% include 'core/info-message.html'  %}
                            <div class="col-md-12">
                                <div class="add-listing-bg">

                                    <div class="row">
                                        
                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/detail_group.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-th-list"></i> {{ page.title }} </span> {{groupe}}</h2>

                        <div class="row">
                            {% include 'core/info-message.html'  %}
                            <div class="col-md-12">

                                <div class="col-md-5 col-sm-5 col-xs-12 listing-rightbar">

                                    <div class="right-bar">
                                        <h4>{{ groupe.member_count }} Adherents</h4>
                                        <ul class="right-bar-listing">
                                           {% for member in members %}
                                                <li> <a href="#"><i class="fa fa-user" aria-hidden="true"></i> {{ member.user.first_name }} {{ member.user.last_name }} <span>(01)</span></a> </li>
                                            {% endfor %}
                                        </ul>
                                    </div>

                                </div>
                                <div class="col-md-7 col-sm-7 col-xs-12">
                                    <table>
                                        <thead>
                                            <tr>
                                                <td width="30%">Montant cotisation</td>
                                                <th width="20%">{{ groupe.cotisation_price }}</th>
                                                <td width="30%">Montant adhesion</td>
                                                <th width="20%">{{ groupe.adhesion_price }}</th>
                                            </tr>
                                        </thead>
                                    </table>
                                </div>

                            </div>
                        </div>

                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/groups.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-users"></i> {{ page.title }}</span></h2>

                        <div class="row">
                            {% include 'core/info-message.html'  %}
                            <div class="col-md-12">
                                <div class="add-listing-bg">

                                    <div class="row">
                                        {% for member in members %}
                                            <div class="col-md-4 col-sm-6 col-xs-12">
                                                <div class="popular-listing-box">
                                                    <div class="popular-listing-detail">
                                                        <h4 class="p_t20 p_b20 text-center">
                                                            <a href="{% url 'core:page_detail_group' member.groupe.code %}"> {{ member.groupe }}</a>
                                                        </h4>
                                                        <p> {{ member.groupe.description }}</p>
                                                    </div>
                                                    <div class="popular-listing-add"> 
                                                        <span><i class="fa fa-lock" aria-hidden="true"></i> {{ member.groupe.code }}</span> 
                                                        <span class="pull-right"><i class="fa fa-user" aria-hidden="true"></i> {{ member.groupe.member_count }}</span> 
                                                    </div>
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>

                                </div>
                            </div>
                        </div>

                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/info-message.html
{% for message in messages %}
    <div class="alert alert-{{ message.tags }} text-{{ message.tags }}" role="alert" style="font-size: 20px; font-weight: 500;
    text-align: center;">

      {{ message }}
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
{% endfor %}

core/templates/core/join_group.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-eye"></i> {{ page.title }}</span></h2>

                        <div class="row">
                            {% include 'core/info-message.html'  %}
                            <div class="col-md-12">
                                <div class="add-listing-bg">

                                    <div class="row">

                                        <div class="col-md-12 col-sm-12 col-xs-12">
                                            <form class="registerd" method="post" action="{% url 'core:page_join_group' %}">
                                                {% csrf_token %}
                                                <div class="listing-title-area">
                                                    <div class="form-group">
                                                        <label>Code du groupe <span>*</span></label>
                                                        <input type="text" name="code" maxlength="8" class="form-control" placeholder="Saisir le code de votre groupe">
                                                        <span class="">Retrouver un groupe auquel vous souhaitez adherer par son code de 8 chiffre</span>
                                                    </div>      
                                                </div>
                                                <div class="form-group pull-right">
                                                    <button type="submit">Rejoindre un groupe</button>
                                                </div>
                                            </form>
                                        </div>

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/messages.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-commenting"></i> {{ page.title }}</span></h2>

                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/new_group.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-plus-square"></i> {{ page.title }}</span></h2>

                        <div class="row">
                            {% include 'core/info-message.html'  %}
                            <div class="col-md-12">
                                <div class="add-listing-bg">

                                    <div class="row">

                                        <div class="col-md-12 col-sm-12 col-xs-12">
                                            <form class="registerd" method="post" action="{% url 'core:page_new_group' %}">
                                                {% csrf_token %}
                                                <div class="listing-title-area">

                                                    <div class="form-group">
                                                        <label>Nom du groupe <span>*</span></label>
                                                        <input type="text" name="name" class="form-control" placeholder="Donner un nom a votre groupe">
                                                    </div>

                                                    <div class="form-group">
                                                        <label>Description <span>*</span></label>
                                                        <input type="text" name="description" class="form-control" placeholder="Donner une description a votre groupe">
                                                    </div>

                                                    <div class="row">

                                                        <div class="col-md-6 col-sm-6 col-xs-12">
                                                            <div class="form-group">
                                                        <label>Montant adhesion</label>
                                                        <input type="number" value="0" name="adhesion_price" class="form-control" placeholder="Montant adhesion">
                                                        <span class="">Entrer le monatnt si adhesion est payante</span>
                                                    </div>
                                                        </div>

                                                        <div class="col-md-6 col-sm-6 col-xs-12">
                                                            <div class="form-group">
                                                        <label>Montant cotisation</label>
                                                        <input type="number" value="0" name="cotisation_price" class="form-control" placeholder="Montant cotisation">
                                                        </div>
                                                        </div>

                                                    </div>
                                                </div>
                                                <div class="form-group pull-right">
                                                    <button type="submit">Créer mon groupe</button>
                                                </div>
                                            </form>
                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>

                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/settings.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-cogs"></i> {{ page.title }}</span></h2>

                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}

core/templates/core/validation.html
{% extends 'base/base.html' %}

{% block content %} 
    <section id="profile" class="p_b70 p_t70 bg_lightgry">

        <div class="container">
            <div class="row">

                <div class="col-md-3 col-sm-3 col-xs-6">
                    {########### Header  ########}
                    {% include 'authentification/login_menu.html' %}
                </div>

                <div class="col-md-9 col-sm-9 col-xs-12">

                    <div class="profile-login-bg">
                        <h2><span><i class="fa fa-check"></i> {{ page.title }}</span></h2>

                        <div class="row">
                            {% include 'core/info-message.html'  %}
                            <div class="col-md-12">
                                <div class="add-listing-bg">
                                    <div class="row">
                                        {% for member in members %}
                                            <div class="col-md-6 col-sm-6 col-xs-12">
                                                <div class="popular-listing-box">
                                                    <div class="popular-listing-img">
                                                        <figure class="effect-ming"> <img src="pdg_image_default.jpg" alt="{{member.groupe}}">
                                                            <figcaption>
                                                                <ul>                                                                    
                                                                    <li>
                                                                        <form action="{% url 'core:page_validate' member.id %}" method="post">
                                                                            {% csrf_token %}
                                                                            <button type="submit"><a href="#!"><i class="fa fa-check" aria-hidden="true"></i></a></button>
                                                                        </form>
                                                                    </li>
                                                                    <li><a href="#!"><i class="fa fa-remove" aria-hidden="true"></i></a></li>
                                                                </ul>
                                                            </figcaption>
                                                        </figure>
                                                    </div>
                                                    <div class="popular-listing-detail">
                                                        <h3><a href="#">{{member.user.username}}</a></h3>
                                                        <p><i class="fa fa-adress" aria-hidden="true"></i> {{member.user.email}}</p>
                                                        <p><i class="fa fa-calendar" aria-hidden="true"></i> {{member.add}}</p>
                                                    </div>
                                                    <div class="popular-listing-add"> 
                                                        <span><i class="fa fa-users" aria-hidden="true"></i> {{member.groupe}}</span> 
                                                    </div>
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>

            </div>
        </div>

    </section>
 {% endblock %}